package ppJava.serie02.datatypes;

/**
 * description
 *
 * @author bpei@informatik.uni-kiel.de
 * @author ken@informatik.uni-kiel.de
 *
 * @version 0.1
 */

import java.io.*;
import java.util.*;

public class Count {

	int in, counter;
	String[] i2sDozen = { "null", "eins", "zwei", "drei", "vier", "fünf",
			"sechs", "sieben", "acht", "neun", "zehn", "elf", "zwölf" };

	static Map<Integer, String> i2sSpecials = new HashMap<Integer, String>();

	static {
		i2sSpecials.put(1, "zehn");
		i2sSpecials.put(2, "zwanzig");
		i2sSpecials.put(3, "dreißig");
		i2sSpecials.put(7, "siebzig");
	}

	/*
	 * http://www.java2s.com/
	 */
	private int readLineInt() {

		String line = null;
		int val = 0;
		try {
			BufferedReader is = new BufferedReader(new InputStreamReader(
					System.in));
			line = is.readLine();
			val = Integer.parseInt(line);
		} catch (NumberFormatException ex) {
			System.err.println("Not a valid number: " + line);
			val = 0;
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
			val = 0;
		}
		return val;
	}

	private void readLine() throws Exception {
		this.setInput(readLineInt());
	}

	public void setInput(int input) throws Exception {
		if (input < 0 || input > 9999) {
			// System.out.println("Value out of range");
			throw new Exception("Value out of range");
		} else {
			in = input;
		}
	}

	public int getInput() {
		return in;
	}

	/* einen Zahlenbereich 1..9"tausend/hundert" */
	private String convertRange(int range, String suffix) {

		String result = "";

		if (counter >= range) {
			int tmp = counter / range;
			if (tmp > 0)
				result += ((tmp == 1) ? "ein" : i2sDozen[tmp]) + suffix;
			counter -= tmp * range;
		}

		return result;
	}

	public String toString() {

		String result = "";

		counter = getInput();

		if (counter == 0)
			result += i2sDozen[counter];

		result += convertRange(1000, "tausend");
		result += convertRange(100, "hundert");

		/* ganz komischer einzelfall :> ... naja, trick17 wa? */
		if (counter == 17) {
			result += "siebzehn";
			counter -= 17;
		}

		/* bereich 13..99 */
		if (counter > 12) {
			int inDIV = counter / 10;
			int inMOD = counter % 10;

			/* der deutsche dreher: "rest"und"...zig" (mod) */
			// if (inDIV != 1 && inMOD != 0) {
			if (inMOD != 0) {
				result += ((inMOD == 1) ? "ein" : i2sDozen[inMOD]);
				if (inDIV > 1)
					result += "und";
			}

			/* zehn,zwanzig... sonderformen */
			if (inDIV == 1 || inDIV == 2 || inDIV == 3 || inDIV == 7) {
				result += i2sSpecials.get(inDIV);
				/* vierzig...achtzig... etc */
			} else {
				result += i2sDozen[inDIV] + "zig";
			}

			counter -= inDIV * 10;
		} else {
			/* 1..12 */
			if (counter > 0)
				result += i2sDozen[counter];
		}

		return result;
	}

	public static void main(String[] args) {

		Count countDump = new Count();

		for (String s : args) {
			if (s.equals("-t")) {
				int[] testValues = { 0, 1, 2, 12, 13, 21, 70, 71, 100, 101,
						200, 1000, 1010, 9999 };

				// for (int i = 0; i < testValues.length; i++) {
				for (int i : testValues) {
					try {
						countDump.setInput(i);
						System.out.println(countDump.toString());
					} catch (Exception e) {
						System.out.println(e.toString());
					}
				}
			}
		}

		try {
			countDump.readLine();
			System.out.println(countDump.toString());
		} catch (Exception e) {
			System.out.println(e.toString());
		}
	}
}
