package ppJava.serie02.datatypes;

import java.awt.*;
import java.awt.event.*;
import java.util.Random;

import javax.swing.*;

public class CountApplet extends JApplet implements ActionListener {

	private static final long serialVersionUID = 1L;

	JTextArea txtOut;
	JTextField txtUserIn;
	JButton btnUserIn;
	JLabel lbl;
	JMenuBar menuBar;
	JMenu menu;
	JMenuItem menuItem, menuItem2, menuItem3;

	private void addMenu() {
		// Create the menu bar.
		menuBar = new JMenuBar();

		// first menu
		menu = new JMenu("Functions");
		menu.setMnemonic(KeyEvent.VK_F);
		menu.getAccessibleContext().setAccessibleDescription(
				"some functionality");
		menuBar.add(menu);

		// a group of JMenuItems
		menuItem = new JMenuItem("Test", KeyEvent.VK_T);
		menuItem.setActionCommand("testit");
		menuItem.addActionListener(this);
		menu.add(menuItem);

		menuItem2 = new JMenuItem("Input", KeyEvent.VK_I);
		menuItem2.setActionCommand("input");
		menuItem2.addActionListener(this);
		menu.add(menuItem2);

		menuItem3 = new JMenuItem("Randomize", KeyEvent.VK_I);
		menuItem3.setActionCommand("rand");
		menuItem3.addActionListener(this);
		menu.add(menuItem3);

		// second menu
		menu = new JMenu("");
		menu.setMnemonic(KeyEvent.VK_R);
		menu.getAccessibleContext().setAccessibleDescription("r");
		menuBar.add(menu);

		setJMenuBar(menuBar);
	}

	/* all elements and layout (init) */
	private void addTemplate() {

		// new OverlayLayout() // new FlowLayout()
		getContentPane().setLayout(new FlowLayout());

		/* template */
		lbl = new JLabel("pp-Java Serie02: Int2Text");
		add(lbl);

		hr(Color.darkGray);

		txtOut = new JTextArea();
		txtOut.setEditable(false);
		txtOut.setLineWrap(true);
		// txtOut.setAlignmentX(JTextField.RIGHT);

		add(txtOut);

		txtUserIn = new JTextField(10);
		add(txtUserIn);

		btnUserIn = new JButton("ok");
		btnUserIn.setActionCommand("convert");
		btnUserIn.addActionListener(this);
		add(btnUserIn);
	}

	/* a line (canvas) */
	private void hr(Color c) {
		Canvas line = new Canvas();
		line.setSize(1000, 2);
		line.setBackground(c);
		add(line);
	}

	/* hide all elements */
	private void clearView() {
		txtUserIn.setVisible(false);
		txtOut.setVisible(false);
		btnUserIn.setVisible(false);
	}

	/* show textfield for input */
	private void showFormUser() {
		txtOut.setText("");
		txtUserIn.setVisible(true);
		btnUserIn.setVisible(true);
	}

	private int[] randArray(int i) {

		int result[] = new int[i];
		Random rnd = new Random();
		
		for (int j = 0; j < i; j++){			
			result[j] = abs(rnd.nextInt()%10000);			
		}
		
		return result;
	}

	private int abs(int i) {
		return (i < 0) ? -1 * i : i;
	}

	/* convert value from input */
	private void showCounterUser() throws Exception {

		String result;

		txtUserIn.setVisible(true);
		btnUserIn.setVisible(true);

		try {
			int count = Integer.valueOf(txtUserIn.getText());

			Count countDump = new Count();
			countDump.setInput(count);
			result = " Value: " + txtUserIn.getText() + " => "
					+ countDump.toString();

		} catch (NumberFormatException e) {
			result = "invalid input";
		}

		txtOut.setText(txtOut.getText()+"\n"+result);
		txtOut.setVisible(true);
	}

	/* some tests */
	private void showCounterTest(int testValues[]) throws Exception {
		Count countDump = new Count();
		String output = "";

		for (int i : testValues) {
			countDump.setInput(i);
			output += " Value: " + i + " => " + countDump.toString() + "\n";
		}

		txtOut.setText(output);
		txtOut.setVisible(true);
	}

	// Called when this applet is loaded into the browser.
	public void init() {
		// Execute a job on the event-dispatching thread; creating this applet's
		// GUI.
		try {
			SwingUtilities.invokeAndWait(new Runnable() {
				public void run() {
					addTemplate();
					addMenu();
					clearView();
				}
			});
		} catch (Exception e) {
			System.err.println("createGUI didn't complete successfully");
		}
	}

	@Override
	public void actionPerformed(ActionEvent event) {

		clearView();

		try {

			/* some tests */
			if ("testit".equals(event.getActionCommand())) {
				showCounterTest(new int[] { 0, 1, 10, 12, 18, 21, 30, 70, 71, 100,
						99, 101, 123, 200, 1000, 1010, 9999 });
			}
			/* show textfield for input */
			if ("input".equals(event.getActionCommand())) {				
				showFormUser();
			}
			/* convert value from input */
			if ("convert".equals(event.getActionCommand())) {
				showCounterUser();
			}

			if ("rand".equals(event.getActionCommand())) {
				showCounterTest(randArray(25));
			}

		} catch (Exception e) {
			/* display exception */
			txtOut.setText(txtOut.getText() + "\n" + e.toString());
			txtOut.setVisible(true);
		}
	}

}
