package ppJava.serie04.oceanlife;

/**
 * A bubble floating up in the ocean
 * 
 * @author ken, bpei
 * 
 */
public class Bubble extends OceanObject {

	private static final long serialVersionUID = 1L;

	int moveLimit = 0;
	int fixedEndingPos = 0;

	/**
	 * Sets the Limit to where the bubble is allowed to move
	 * 
	 * @param moveLimit
	 */
	public void setMoveLimit(int moveLimit) {
		this.moveLimit = moveLimit;
		this.fixedEndingPos = 0 - (getOffset()[1]);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see ppJava.serie04.oceanlife.OceanObject#toString()
	 */
	@Override
	public String toString() {
		return "Bubble" + super.toString() + "\n";
	}

	/**
	 * Constructor for a bubble at position (x,y)
	 * 
	 * @param x
	 * @param y
	 */
	public Bubble(int x, int y) {
		super();
		int pos[] = { x, y };
		this.setPosition(pos);
		this.setImageResource("res/images/bubbles/pathed_01_small.png");
		this.setImageIcon(createImageIcon(this.getImageResource(), ""));
		int offset[] = { getImageIcon().getIconWidth() / 2,
				getImageIcon().getIconHeight() / 2 };
		this.setOffset(offset);
		int movev[] = { 0, -5 };
		this.setMoveVector(movev);
	}

	/**
	 * The movement of a bubble
	 */
	public void run() {

		if (getPosition()[1] <= fixedEndingPos) {
			getPosition()[1] = moveLimit;
		} else {
			moveStep();
		}

		this.checkBarrier();
	}

}
