package ppJava.serie04.oceanlife;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Custom Exception-class of Ocean with a constructor for a custom message. If
 * an OceanException occurs, it will also be logged as warnings
 */
public class OceanException extends Exception {

	private static final long serialVersionUID = 1L;
	private static Logger logger = Logger.getLogger("ppJava.serie04.oceanlife");

	/**
	 * Default constructor.
	 */
	public OceanException() {
		super();
		logger.log(Level.WARNING, "OceanException()");
	}

	/**
	 * Custom constructor.
	 * 
	 * @param string
	 *            - custom message
	 */
	public OceanException(String string) {
		super(string);
		logger.log(Level.WARNING, "OceanException(): " + string);
	}

}
