package ppJava.serie04.oceanlife;

import java.io.EOFException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

/**
 * Helper-class for file-operations
 * 
 */
public class OceanFileOps {

	/**
	 * Serialize and writes all oceanObjects to a file
	 * 
	 * @param filename
	 * @throws IOException
	 */
	public static void saveOceanObjectFile(String filename, Ocean ocean)
			throws IOException {

		FileOutputStream fos = null;
		ObjectOutputStream out = null;

		fos = new FileOutputStream(filename);
		out = new ObjectOutputStream(fos);

		for (OceanObject oceanObject : ocean.getOceanObjects()) {
			out.writeObject(oceanObject);
		}

		out.close();

	}

	/**
	 * Reads a file of serialized oceanObjects and adds all items into the ocean
	 * 
	 * @param filename
	 * @return a ocean with linked list of oceanObjects
	 * @throws IOException
	 * @throws ClassNotFoundException
	 */
	public static OceanInterface loadOceanObjectFile(String filename,
			Ocean ocean) throws IOException, ClassNotFoundException {

		FileInputStream fileIn = null;
		ObjectInputStream in = null;

		try {

			fileIn = new FileInputStream(filename);
			in = new ObjectInputStream(fileIn);

			OceanObject object = null;

			while ((object = (OceanObject) in.readObject()) != null) {
				// addNewObject(object);
				
				try {
					ocean.addOceanObject(object);
				} catch (OceanException e) {
					
					//e.printStackTrace();
				}
				// System.out.println(object.toString());
			}

			// read the file until EOF
		} catch (EOFException e) {
			System.out.println("EOF");
		} catch (FileNotFoundException e) {
			e.printStackTrace();		

		} finally {
			try {
				in.close();
				fileIn.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
		return ocean;

	}
}
