/**
 * 
 */
package ppJava.serie04.oceanlife;

import java.util.LinkedList;

import junit.framework.TestCase;

/**
 * Some Tests (incomplete)
 * 
 */
public class OceanObjectJUnitTest extends TestCase {

	// objectTest
	int x = -1;
	int y = 1000;
	int position[] = { x, y };

	LinkedList<OceanObject> objList = new LinkedList<OceanObject>();

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	/**
	 * @param position
	 * @param oceanObject
	 */
	private void checkNewObject(int[] position, OceanObject oceanObject) {

		assertTrue("Position didn't match", position[0] == oceanObject
				.getPosition()[0]
				&& position[1] == oceanObject.getPosition()[1]);

		objList.add(oceanObject);
	}

	/**
	 * @param count
	 */
	private void checkObjectCount(int count) {

		assertTrue("Object count didn't increase", count == OceanObject
				.getObjectCount());
	}

	/**
	 * @param oceanObject
	 */
	private void checkObjectPosition(OceanObject oceanObject) {

		try {
			oceanObject.checkPosition(new Ocean(1,
					oceanObject.getPosition()[1] - 1, null));
			fail("Object has invalid position => throw OceanException");
		} catch (OceanException e) {
			// TODO: handle exception
		}
	}

	/* public means this will be called by jUnit */

	/**
	 * @throws Exception
	 */
	public void testOceanWidth() throws Exception {

		@SuppressWarnings("unused")
		Ocean ocean;
		try {
			ocean = new Ocean(-1, 200, null);
			fail("Ocean has invalid width => throw OceanException");
		} catch (OceanException e) {
			// TODO: handle exception
		}
	}

	/**
	 * @throws Exception
	 */
	public void testAddOceanObjectBubble() throws Exception {

		Bubble tBubble = new Bubble(x, y);
		checkNewObject(position, tBubble);
		checkObjectCount(1);
		checkObjectPosition(tBubble);
	}

	/**
	 * @throws Exception
	 */
	public void testAddOceanObjectStone() throws Exception {

		Stone tStone = new Stone(x, y);
		checkNewObject(position, tStone);
		checkObjectCount(2);
		checkObjectPosition(tStone);
	}

	/**
	 * @throws Exception
	 */
	public void testAddOceanObjectPlant() throws Exception {

		Plant tPlant = new Plant(x, y);
		checkNewObject(position, tPlant);
		checkObjectCount(3);
		checkObjectPosition(tPlant);
	}

	/**
	 * @throws Exception
	 */
	public void testAddOceanObjectFish() throws Exception {

		Fish tFish = new Fish(x, y);
		checkNewObject(position, tFish);
		checkObjectCount(4);
		checkObjectPosition(tFish);
	}

	public void testAppendOceanObject() throws Exception {
		int cnt = objList.size();

		Ocean testOcean = new Ocean(100, 200, objList);

		try {
			testOcean.addOceanObject(new Fish(101, 100));
			fail("Fish has invalid position => throw OceanException");
		} catch (OceanException e) {
			// TODO: handle exception
		}

		assertTrue("Object invalid but added", cnt == objList.size());

		try {
			testOcean.addOceanObject(new Fish(50, -1));
			fail("Fish has invalid position => throw OceanException");
		} catch (OceanException e) {
			// TODO: handle exception
		}

		assertTrue("Object invalid but added", cnt == objList.size());
	}

	public void testGetNextObjectInRange() throws Exception {

		Ocean testOcean = new Ocean(200, 200, objList);
		int position[] = { 99, 100 };

		testOcean.addOceanObject(new Fish(10, 10));
		testOcean.addOceanObject(new Fish(100, 100));
		testOcean.addOceanObject(new Fish(90, 10));

		assertTrue("This is not the next", testOcean
				.indexOfNearestObject(position) == 1);

		position[0] = 40;
		position[1] = 80;

		assertTrue("This is not the next", testOcean
				.indexOfNearestObject(position) == 1);

		position[0] = 0;
		position[1] = 0;

		assertTrue("This is not the next", testOcean
				.indexOfNearestObject(position) == 0);

		position[0] = 60;
		position[1] = 30;

		assertTrue("This is not the next", testOcean
				.indexOfNearestObject(position) == 2);

	}

	/**
	 * @throws Exception
	 */
	public void testRemoveObjectAtIndex() throws Exception {

		Ocean ocean;
		try {
			ocean = new Ocean(100, 200, objList);
			ocean.removeOceanObject(objList.size() + 1);
			fail("Object not found => throw OceanException");
		} catch (OceanException e) {
			// TODO: handle exception
		}
	}

	/**
	 * @throws Exception
	 */
	public void testDistance() throws Exception {
		/*Ocean testOcean = new Ocean(200, 200, objList);
		int position[] = { 99, 100 };

		testOcean.appendOceanObject(new Fish(10, 10));
		testOcean.appendOceanObject(new Fish(100, 100));

		OceanObject testObject = new Fish(0, 0);
		OceanObject testObject2 = new Fish(10, 10);*/

		// assertTrue("This is not the real distance",
		// testObject.getDistance(testObject2.getPosition()) == );
	}

	/**
	 * @throws Exception
	 */
	public void testOceanObjects() throws Exception {

	}
}
