package ppJava.serie04.oceanlife;

/**
 * A plant, growing in the ocean
 * 
 * @author ken, bpei
 * 
 */
public class Plant extends OceanObject {

	private static final long serialVersionUID = 1L;

	int moveLimit = 0;
	int fixedEndingPos = 0;

	/**
	 * Sets the Limit to where the plant is allowed to move
	 * 
	 * @param moveLimit
	 */
	public void setMoveLimit(int moveLimit) {
		this.moveLimit = moveLimit;
		this.fixedEndingPos = moveLimit - 150;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see ppJava.serie04.oceanlife.OceanObject#toString()
	 */
	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return "Plant" + super.toString() + "\n";
	}

	/**
	 * Constructor for a plant at position (x,y)
	 * 
	 * @param x
	 * @param y
	 */
	public Plant(int x, int y) {
		super();
		int pos[] = { x, y };
		this.setPosition(pos);
		this.setImageResource("res/images/plants/pathed_02.png");
		this.setImageIcon(createImageIcon(this.getImageResource(), ""));
		int offset[] = { getImageIcon().getIconWidth() / 2,
				getImageIcon().getIconHeight() / 2 };
		this.setOffset(offset);
		int movev[] = { 0, -5 };
		this.setMoveVector(movev);
	}

	/**
	 * The movement of a plant
	 */
	public void run() {

		if (getPosition()[1] > fixedEndingPos) {
			moveStep();
		}
		this.checkBarrier();
	}

}
