package ppJava.serie04.oceanlife;

/**
 * A stone falling down in the ocean
 * @author ken, bpei
 *
 */
public class Stone extends OceanObject {

	private static final long serialVersionUID = 1L;
	
	int moveLimit = 0;
	int fixedEndingPos = 0;

	/**
	 * Sets the Limit to where the stone is allowed to move
	 * @param moveLimit
	 */
	public void setMoveLimit(int moveLimit) {
		this.moveLimit = moveLimit;
		this.fixedEndingPos = moveLimit - 150;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see ppJava.serie04.oceanlife.OceanObject#toString()
	 */
	@Override
	public String toString() {
		return "Stone" + super.toString() + "\n";
	}


	/**
	 * Constructor for a stone at the position (x,y)
	 * @param x
	 * @param y
	 */
	public Stone(int x, int y) {
		super();
		int pos[] = { x, y };
		this.setPosition(pos);
		this.setImageResource("res/images/rocks/pathed_01.png");
		this.setImageIcon(createImageIcon(this.getImageResource(), ""));
		int offset[] = { getImageIcon().getIconWidth() / 2,
				getImageIcon().getIconHeight() / 2 };
		this.setOffset(offset);
		int movev[] = { 0, 10 };
		this.setMoveVector(movev);
	}

	/**
	 * The movement of a stone
	 */
	public void run() {
		
		if (getPosition()[1] < fixedEndingPos) {
			moveStep();
		}
		this.checkBarrier();
	}

}
